Index: src/sas/sasgui/guiframe/CategoryInstaller.py
===================================================================
--- src/sas/sasgui/guiframe/CategoryInstaller.py	(revision a26f67f1457e7e39b79d4c3800c03bcaa208dff7)
+++ src/sas/sasgui/guiframe/CategoryInstaller.py	(revision cb64d86aa05427be27c71cc415727ce4d7fdce69)
@@ -20,4 +20,13 @@
 
 logger = logging.getLogger(__name__)
+
+if sys.version_info[0] > 2:
+    def json_dump(obj, filename):
+        with open(filename, 'w', newline='\n') as fd:
+            json.dump(obj, fd)
+else: # CRUFT: python 2.7 support
+    def json_dump(obj, filename):
+        with open(filename, 'wb') as fd:
+            json.dump(obj, fd)
 
 class CategoryInstaller(object):
@@ -121,5 +130,5 @@
         """
         _model_dict = {model.name: model for model in model_list}
-        _model_list = _model_dict.keys()
+        _model_list = list(_model_dict.keys())
 
         serialized_file = None
@@ -146,6 +155,6 @@
                         by_model_dict.pop(model_name)
                         model_enabled_dict.pop(model_name)
-                    except Exception:
-                        logger.error("CategoryInstaller: %s", sys.exc_value)
+                    except Exception as exc:
+                        logger.error("CategoryInstaller: %s", exc)
                 else:
                     add_list.remove(model_name)
@@ -171,3 +180,3 @@
                                                           model_enabled_dict)
 
-            json.dump(master_category_dict, open(serialized_file, 'wb'))
+            json_dump(master_category_dict, serialized_file)
Index: src/sas/sasgui/guiframe/CategoryManager.py
===================================================================
--- src/sas/sasgui/guiframe/CategoryManager.py	(revision 463e7ffce130ae386f93cd18b87a1120743e88b5)
+++ src/sas/sasgui/guiframe/CategoryManager.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -230,5 +230,5 @@
 
         for model in model_name_list:
-            index = self.cat_list.InsertStringItem(sys.maxint, model)
+            index = self.cat_list.InsertStringItem(sys.maxsize, model)
             self.cat_list.SetStringItem(index, 1, \
                                             str(self.by_model_dict[model]).\
@@ -384,5 +384,5 @@
         """
         cat_list = list()
-        for category in self.master_category_dict.iterkeys():
+        for category in self.master_category_dict.keys():
             if not category == 'Uncategorized':
                 cat_list.append(category)
Index: src/sas/sasgui/guiframe/custom_pstats.py
===================================================================
--- src/sas/sasgui/guiframe/custom_pstats.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/custom_pstats.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -36,30 +36,30 @@
         width = self.max_name_len
         if self.fcn_list:
-            list = self.fcn_list[:]
+            stats = self.fcn_list[:]
             temp_msg = "   Ordered by: " + self.sort_type + '\n'
         else:
-            list = self.stats.keys()
+            stats = list(self.stats.keys())
             temp_msg = "   Random listing order was used\n"
 
         for selection in amount:
-            list, temp_msg = self.eval_print_amount(selection, list, temp_msg)
+            stats, temp_msg = self.eval_print_amount(selection, stats, temp_msg)
 
-        count = len(list)
+        count = len(stats)
 
-        if not list:
-            width, list = 0, list
+        if not stats:
+            width = 0
         else:
-            msg +=   str(temp_msg) + '\n'
+            msg += str(temp_msg) + '\n'
             if count < len(self.stats):
                 width = 0
-                for func in list:
+                for func in stats:
                     if  len(func_std_string(func)) > width:
                         width = len(func_std_string(func))
        
-            width, list = width+2, list
-        if list:
+            width = width+2
+        if stats:
             msg += '   ncalls  tottime  percall  cumtime  percall'
             msg +=  ' filename:lineno(function)' + "\n"
-            for func in list:
+            for func in stats:
                 cc, nc, tt, ct, callers = self.stats[func]
                 c = str(nc)
Index: src/sas/sasgui/guiframe/data_manager.py
===================================================================
--- src/sas/sasgui/guiframe/data_manager.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/data_manager.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -51,5 +51,5 @@
         _str += "No of states  is %s \n" % str(len(self.stored_data))
         n_count = 0
-        for  value in self.stored_data.values():
+        for value in self.stored_data.values():
             n_count += 1 
             _str += "State No %s \n"  % str(n_count)
@@ -134,5 +134,5 @@
         receive a list of 
         """
-        for id, data in data_list.iteritems():
+        for id, data in data_list.items():
             if id  in self.stored_data:
                 msg = "Data manager already stores %s" % str(data.name)
@@ -150,10 +150,10 @@
         """
         """
-        if prev_data.id not in self.stored_data.keys():
+        if prev_data.id not in self.stored_data:
             return None, {}
         data_state = self.stored_data[prev_data.id] 
         self.stored_data[new_data.id]  = data_state.clone()
         self.stored_data[new_data.id].data = new_data
-        if prev_data.id in self.stored_data.keys():
+        if prev_data.id in self.stored_data:
             del self.stored_data[prev_data.id] 
         return prev_data.id, {new_data.id: self.stored_data[new_data.id]}
@@ -165,5 +165,5 @@
         if data_id is None and theory is not None:
             uid = theory.id
-        if uid in self.stored_data.keys():
+        if uid in self.stored_data:
              data_state = self.stored_data[uid] 
         else:
@@ -195,5 +195,5 @@
                 if search_id == d_id:
                     _selected_data[search_id] = data
-                if search_id in theory_list.keys():
+                if search_id in theory_list:
                      _selected_theory_list[search_id] = theory_list[search_id]
                    
@@ -204,5 +204,5 @@
         """
         """
-        return self.freeze_theory(self.stored_data.keys(), theory_id)
+        return self.freeze_theory(list(self.stored_data.keys()), theory_id)
         
     def freeze_theory(self, data_id, theory_id):
@@ -215,5 +215,5 @@
                 theory_list = data_state.get_theory()
                 for t_id in theory_id:
-                    if t_id in theory_list.keys():
+                    if t_id in theory_list:
                         theory_data, theory_state = theory_list[t_id]
                         new_theory = copy.deepcopy(theory_data)
@@ -235,5 +235,5 @@
         """
         for d_id in data_id:
-            if d_id in self.stored_data.keys():
+            if d_id in self.stored_data:
                 data_state = self.stored_data[d_id]
                 if data_state.data.name in self.data_name_dict:
@@ -253,5 +253,5 @@
                 data_state = self.stored_data[d_id]
                 theory_list = data_state.get_theory()
-                if theory_id in theory_list.keys():
+                if theory_id in theory_list:
                     del theory_list[theory_id]
         #del pure theory
@@ -273,5 +273,5 @@
         _selected_data = {}
         for selected_name in name_list:
-            for id, data_state in self.stored_data.iteritems():
+            for id, data_state in self.stored_data.items():
                 if data_state.data.name == selected_name:
                     _selected_data[id] = data_state.data
@@ -283,5 +283,5 @@
         """
         for selected_name in name_list:
-            for id, data_state in self.stored_data.iteritems():
+            for id, data_state in self.stored_data.items():
                 if data_state.data.name == selected_name:
                     del self.stored_data[id]
@@ -293,5 +293,5 @@
         _selected_data_state = {}
         for id in data_id:
-            if id in self.stored_data.keys():
+            if id in self.stored_data:
                 _selected_data_state[id] = self.stored_data[id]
         return _selected_data_state
@@ -303,4 +303,2 @@
         return self.stored_data
     
-
-        
Index: src/sas/sasgui/guiframe/data_panel.py
===================================================================
--- src/sas/sasgui/guiframe/data_panel.py	(revision b963b2066d6a76fe5073000c5a596a6fd0130ac4)
+++ src/sas/sasgui/guiframe/data_panel.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -13,10 +13,11 @@
 from __future__ import print_function
 
+import sys
+
 import wx
-from wx.build import build_options
-
-import sys
 from wx.lib.scrolledpanel import ScrolledPanel
 import wx.lib.agw.customtreectrl as CT
+#from wx.build import build_options
+
 from sas.sasgui.guiframe.dataFitting import Data1D
 from sas.sasgui.guiframe.dataFitting import Data2D
@@ -444,7 +445,7 @@
             self.parent.get_data_manager().get_by_id(id_list=[id])
         if data_list:
-            data = data_list.values()[0]
+            data = list(data_list.values())[0]
         if data is None:
-            data = theory_list.values()[0][0]
+            data = list(theory_list.values())[0][0]
         return data
 
@@ -667,5 +668,5 @@
         """
         if list:
-            for state_id, dstate in list.iteritems():
+            for state_id, dstate in list.items():
                 data = dstate.get_data()
                 theory_list = dstate.get_theory()
@@ -764,5 +765,5 @@
         if not theory_list:
             return
-        if state_id not in self.list_cb_data.keys():
+        if state_id not in self.list_cb_data:
             root = self.tree_ctrl_theory.root
             tree = self.tree_ctrl_theory
@@ -783,9 +784,9 @@
         Append theory helper
         """
-        if state_id in self.list_cb_theory.keys():
+        if state_id in self.list_cb_theory:
             # update current list of theory for this data
             theory_list_ctrl = self.list_cb_theory[state_id]
 
-            for theory_id, item in theory_list.iteritems():
+            for theory_id, item in theory_list.items():
                 theory_data, _ = item
                 if theory_data is None:
@@ -828,5 +829,5 @@
             # data didn't have a theory associated it before
             theory_list_ctrl = {}
-            for theory_id, item in theory_list.iteritems():
+            for theory_id, item in theory_list.items():
                 theory_data, _ = item
                 if theory_data is not None:
@@ -868,5 +869,5 @@
 
         for theory_dict in self.list_cb_theory.values():
-            for _, value in theory_dict.iteritems():
+            for _, value in theory_dict.items():
                 item, _, _ = value
                 if item.IsChecked():
@@ -924,15 +925,15 @@
         theory_key = []
         # remove  data from treectrl
-        for d_key, item in self.list_cb_data.iteritems():
+        for d_key, item in self.list_cb_data.items():
             data_c, _, _, _,  _, _, _, _ = item
             if data_c.IsChecked():
                 self.tree_ctrl.Delete(data_c)
                 data_key.append(d_key)
-                if d_key in self.list_cb_theory.keys():
+                if d_key in self.list_cb_theory:
                     theory_list_ctrl = self.list_cb_theory[d_key]
-                    theory_to_remove += theory_list_ctrl.keys()
+                    theory_to_remove += list(theory_list_ctrl.keys())
         # Remove theory from treectrl
-        for _, theory_dict in self.list_cb_theory.iteritems():
-            for key, value in theory_dict.iteritems():
+        for _, theory_dict in self.list_cb_theory.items():
+            for key, value in theory_dict.items():
                 item, _, _ = value
                 if item.IsChecked():
@@ -950,7 +951,7 @@
         # remove theory  references independently of data
         for key in theory_key:
-            for _, theory_dict in self.list_cb_theory.iteritems():
+            for _, theory_dict in self.list_cb_theory.items():
                 if key in theory_dict:
-                    for key, value in theory_dict.iteritems():
+                    for key, value in theory_dict.items():
                         item, _, _ = value
                         if item.IsChecked():
@@ -1047,5 +1048,5 @@
         if self.cb_plotpanel and self.cb_plotpanel.IsBeingDeleted():
             return
-        for _, value in self.parent.plot_panels.iteritems():
+        for _, value in self.parent.plot_panels.items():
             name_plot_panel = str(value.window_caption)
             if name_plot_panel not in self.cb_plotpanel.GetItems():
@@ -1129,5 +1130,5 @@
         #import documentation window here to avoid circular imports
         #if put at top of file with rest of imports.
-        from documentation_window import DocumentationWindow
+        from .documentation_window import DocumentationWindow
 
         _TreeLocation = "user/sasgui/guiframe/data_explorer_help.html"
@@ -1499,7 +1500,7 @@
         window.Show(True)
         window.load_data_list(list=temp_data_list)
-    except:
+    except Exception as exc:
         # raise
-        print("error", sys.exc_value)
+        print("error", exc)
 
     app.MainLoop()
Index: src/sas/sasgui/guiframe/data_processor.py
===================================================================
--- src/sas/sasgui/guiframe/data_processor.py	(revision 20fa5fe0c3e314a850432d5e463d03ceed3e453a)
+++ src/sas/sasgui/guiframe/data_processor.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -234,5 +234,10 @@
         # overriden in this subclassn - actually we have currently
         # disabled the on_context_menu that would override the OnRightClick
-        self.Bind(wx.grid.EVT_GRID_CELL_CHANGE, self.OnCellChange)
+        try:
+            EVT_GRID_CELL_CHANGED = wx.grid.EVT_GRID_CELL_CHANGED
+        except AttributeError:
+            # CRUFT: wx 3.x uses CHANGE rather than CHANGING/CHANGED
+            EVT_GRID_CELL_CHANGED = wx.grid.EVT_GRID_CELL_CHANGE
+        self.Bind(EVT_GRID_CELL_CHANGED, self.OnCellChange)
         self.Bind(wx.grid.EVT_GRID_CELL_LEFT_CLICK, self.OnLeftClick)
         self.Bind(wx.grid.EVT_GRID_CELL_RIGHT_CLICK, self.OnRightClick)
@@ -561,5 +566,5 @@
                 value = self.GetCellValue(row, col)
                 self.data[col_name].append(value)
-                for k, value_list in self.data.iteritems():
+                for k, value_list in self.data.items():
                     if k != col_name:
                         length = len(value_list)
@@ -621,5 +626,5 @@
         if col_name.strip() != "Empty":
             self.SetCellValue(row, col, str(col_name.strip()))
-        if col_name in self.data.keys():
+        if col_name in self.data:
             value_list = self.data[col_name]
             cell_row = 1
@@ -674,5 +679,5 @@
             self._cols = self.GetNumberCols()
             self._rows = self.GetNumberRows()
-            self.col_names = self.data_outputs.keys()
+            self.col_names = list(self.data_outputs.keys())
             self.col_names.sort()
             nbr_user_cols = len(self.col_names)
@@ -682,5 +687,5 @@
                 self.AppendCols(new_col_nbr, True)
             #Add more rows to the grid if necessary
-            nbr_user_row = len(self.data_outputs.values()[0])
+            nbr_user_row = len(list(self.data_outputs.values())[0])
             if nbr_user_row > self._rows + 1:
                 new_row_nbr = nbr_user_row - self._rows + 1
@@ -909,5 +914,5 @@
                     msg = "Edit axis doesn't understand this selection.\n"
                     msg += "Please select only one column"
-                    raise ValueError, msg
+                    raise ValueError(msg)
             for (_, cell_col) in grid.selected_cells:
                 if cell_col != col:
@@ -915,5 +920,5 @@
                     msg += "this operation.\n"
                     msg += "Please select elements of the same col.\n"
-                    raise ValueError, msg
+                    raise ValueError(msg)
 
             # Finally check the highlighted cell if any cells missing
@@ -922,5 +927,5 @@
             msg = "No item selected.\n"
             msg += "Please select only one column or one cell"
-            raise ValueError, msg
+            raise ValueError(msg)
         return grid.selected_cells
 
@@ -1326,5 +1331,5 @@
             if sentence.strip() == "":
                 msg = "Select column values for x axis"
-                raise ValueError, msg
+                raise ValueError(msg)
         except:
             msg = "X axis value error."
@@ -1345,5 +1350,5 @@
             if sentence.strip() == "":
                 msg = "select value for y axis"
-                raise ValueError, msg
+                raise ValueError(msg)
         except:
             msg = "Y axis value error."
@@ -1440,5 +1445,5 @@
         """
 
-        for tok, (col_name, list) in dict.iteritems():
+        for tok, (col_name, list) in dict.items():
             col = column_names[col_name]
             axis = self.get_plot_axis(col, list)
@@ -1446,5 +1451,5 @@
                 return None
             sentence = sentence.replace(tok, "numpy.array(%s)" % str(axis))
-        for key, value in FUNC_DICT.iteritems():
+        for key, value in FUNC_DICT.items():
             sentence = sentence.replace(key.lower(), value)
         return sentence
@@ -1546,6 +1551,6 @@
             cell_list = self.notebook.on_edit_axis()
             label, title = self.create_axis_label(cell_list)
-        except:
-            msg = str(sys.exc_value)
+        except Exception as exc:
+            msg = str(exc)
             wx.PostEvent(self.parent.parent, StatusEvent(status=msg, info="error"))
             return
@@ -2036,6 +2041,6 @@
         frame = GridFrame(data_outputs=data, data_inputs=data_input)
         frame.Show(True)
-    except:
-        print(sys.exc_value)
+    except Exception as exc:
+        print(exc)
 
     app.MainLoop()
Index: src/sas/sasgui/guiframe/data_state.py
===================================================================
--- src/sas/sasgui/guiframe/data_state.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ src/sas/sasgui/guiframe/data_state.py	(revision 5251ec6db8aae214addfa0a5a1da16820994958b)
@@ -37,5 +37,5 @@
         _str += "Theories available: %s \n" % len(self.theory_list)
         if self.theory_list:
-            for id, item in self.theory_list.iteritems():
+            for id, item in self.theory_list.items():
                 theory_data, theory_state = item
                 _str += "Theory name : %s \n" % str(theory_data.name)
@@ -53,5 +53,5 @@
         obj.message = self.message
         obj.id = self.id
-        for id, item in self.theory_list.iteritems():
+        for id, item in self.theory_list.items():
             theory_data, theory_state = item
             state = None
@@ -95,5 +95,5 @@
         """
         self.theory_list[theory_data.id] = [theory_data, theory_state]
-        data, state = self.theory_list.values()[0]
+        data, state = list(self.theory_list.values())[0]
        
     def get_theory(self):
@@ -106,3 +106,2 @@
         return self.message
     
-  
